#include <stdio.h>

struct datum {
    short tag, monat, jahr;
};

    /* call-by-value-Semantik */
void ausgabe1(struct datum d) {
    printf("%d.%d.%d\n", d.tag, d.monat, d.jahr);
}

    /* call-by-reference-Semantik (hier egal) */
void ausgabe2(struct datum *d) {
    printf("%d.%d.%d\n", d->tag, d->monat, d->jahr);
}

    /* call-by-value-Semantik => aendert nichts, da d Kopie! */
void setJahr1(struct datum d, int jahr) {
    d.jahr = jahr;
}

    /* call-by-reference-Semantik => gewuenschtes Ergebnis */
void setJahr2(struct datum *d, int jahr) {
    d->jahr = jahr;
}

int main() {
    struct datum start = {13, 10, 2003};

    ausgabe1(start);
    setJahr1(start, 2004);	/* keine Aenderung! */
    ausgabe2(&start);		/* aequivalent zu ausgabe1(...) */
    setJahr2(&start, 2004);	/* setzt das Jahr auf 2004 */
    ausgabe1(start);

    return 0;
}
